%  Beamer slide example.

\documentclass[9pt]{beamer}
\usepackage[utf8]{inputenc}
\usepackage{tikz}
\usepackage{subfig}
\usepackage{graphicx}
\usepackage{xcolor}
\usepackage{blkarray}
\usepackage{biblatex}
\usepackage{anyfontsize}
\usepackage{pdfpages}
\addbibresource{Publication1.bib}
\usetikzlibrary{positioning}
\usetikzlibrary{shapes,snakes}
\usetheme{inria}
\usepackage{helvet}
\author[David Bromberg, Quentin Dufour, Davide Frey]{David Bromberg, Quentin Dufour, Davide Frey\\~\emph{Univ Rennes, Inria, CNRS, IRISA}\\~firstname.name@inria.fr}

\title[Multisource Rumor Spreading with Network Coding]{Multisource Rumor Spreading\\[2mm]~with Network Coding}
\subtitle{INFOCOM 2019}

% Automatically insert a "new section" page at each section.
\AtBeginSection[]{
  \begin{frame}[plain]
    \partpage
  \end{frame} 
}

% \inriaswitchcolors COLOR
%
% Where COLOR is one of red, blue, orange, darkblue, violet,
% pastelgreen, grey, or green.
\newcommand{\inriaswitchcolors}[1]{%
\pgfaliasimage{figfootline}{figfootline-#1}% !!!
\pgfaliasimage{figbackground}{figbackground-#1}% !!!
\pgfaliasimage{figbackground}{figbackground-#1}% !!!
}

\tikzset{
diagonal fill/.style 2 args={fill=#2, path picture={
\fill[#1, sharp corners] (path picture bounding box.south west) -|
                         (path picture bounding box.north east) -- cycle;}}
}

\newcommand{\nothing}{}
\newcommand{\comp}{\includegraphics[scale=0.13]{img/computer.png}}
\newcommand{\compnew}{\includegraphics[scale=0.13]{img/computer-new.png}}
\newcommand{\compbrok}{\includegraphics[scale=0.13]{img/computer-broken.png}}
\newcommand{\compsad}{\includegraphics[scale=0.13]{img/computer-sad.png}}
\newcommand{\compmailb}{\includegraphics[scale=0.13]{img/computer+mail+blue.png}}
\newcommand{\compmailr}{\includegraphics[scale=0.13]{img/computer+mail+red.png}}
\newcommand{\compmailbr}{\includegraphics[scale=0.13]{img/computer+mail+bluered.png}}
\newcommand{\compmailby}{\includegraphics[scale=0.13]{img/computer+mail+blueyellow.png}}
\newcommand{\compmailry}{\includegraphics[scale=0.13]{img/computer+mail+redyellow.png}}
\newcommand{\compmailbry}{\includegraphics[scale=0.13]{img/computer+mail+blueredyellow.png}}

\begin{document}

% starting the document
% *********************

% titlepage
% ---------
\begin{frame}[plain]
\titlepage
\end{frame}

% table of contents
% -----------------
%\begin{frame}{\textcolor{inriaGrey}{Contents}}
%  \tableofcontents
%\end{frame}

% original template slides
% ************************
 

% Introduction slide
% ------------------

\begin{frame}
  \begin{tikzpicture}[scale=1]
  \node (logo) at (0,0) {\includegraphics[scale=1]{img/bitcoin.png}};
  \node[right = 0.5cm of logo] (question) {\Huge Broadcast transaction hashes};
  \node[below = 0.0cm of question] {\Large on the Bitcoin network?};

  \node[below = 1cm of logo] (computer) {\includegraphics[scale=0.26]{img/computer.png}};
  \node[right = 0cm of computer] (comptext) {\Huge 10 000 nodes};
  
  \node[right = 1cm of comptext] (transaction) {\includegraphics[scale=1.3]{img/transaction.png}};
  \node[right = 0cm of transaction] (txtext) {\Huge 7 tx/sec};

  \node[below right = 1cm and 2.5cm of computer] (figure) {\fontsize{50}{60}\selectfont \textcolor{red}{16x}};
  \node[below  = 0.2cm of figure] (explain) {\Large In average, a node receives the \textbf{same} transaction hash 16x times};
  \end{tikzpicture}
\end{frame}

\begin{frame}
  \frametitle{Not a Trivial Problem}

    %\node (a) at (0, 0) {\comp};
    %\draw[->, black!60!green, every node/.style={sloped,anchor=south}] (d) edge node{send} (c);
\begin{figure}[h]
  \begin{tikzpicture}[scale=1]
  \input{|"./naive-tikz"}
  \end{tikzpicture}
\end{figure}
\end{frame}

\begin{frame}
  \frametitle{Make Nodes Collaborate: a Push-Only Protocol}

\textbf{Each node forwards the message to $k$ (fanout) random nodes.} \\
($k=2$ here, $k=16$ for bitcoin tx hashes)
\vspace{-1em}
\begin{figure}[h]
  \begin{tikzpicture}[scale=1.8]
    \clip (-0.5, 2.5) rectangle (6, -1.5);
    \node (d) at (3, 1) {\compmailr};
    \only<1> {
      \node (c) at (2, -0.5) {\comp};
      \node (e) at (4, 2) {\comp};
      \node (f) at (5, 0) {\comp};
      \node (a) at (0, 0) {\comp};
      \node (b) at (1, 1) {\comp};
    }
    \only<2>{
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (d) edge node{send} (f);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (d) edge node{send} (b);
      \node (a) at (0, 0) {\comp};
      \node (c) at (2, -0.5) {\comp};
      \node (e) at (4, 2) {\comp};
      \node (f) at (5, 0) {\compmailr};
      \node (b) at (1, 1) { \compmailr };
    };
    \only<3>{
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (d) edge (f);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (d) edge (b);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (f) edge node{send} (b);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (f) edge node{send} (e);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (b) edge node{send} (e);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (b) edge node{send} (a);
      \node (c) at (2, -0.5) {\comp};
      \node (f) at (5, 0) {\compmailr};
      \node (b) at (1, 1) {\compmailr};
      \node (a) at (0, 0) {\compmailr};
      \node (e) at (4, 2) {\compmailr};
    };
    \only<4>{
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (d) edge (f);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (d) edge (b);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (f) edge (b);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (f) edge (e);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (b) edge (e);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (b) edge (a);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (a) edge node{send} (c);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (a) edge node{send} (d);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (e) edge node{send} (a);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (e) edge node{send} (d);
      \node (b) at (1, 1) {\compmailr};
      \node (c) at (2, -0.5) {\compmailr};
      \node (f) at (5, 0) {\compmailr};
      \node (a) at (0, 0) {\compmailr};
      \node (e) at (4, 2) {\compmailr};
    };
   \only<5>{
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (d) edge (f);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (d) edge (b);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (f) edge (b);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (f) edge (e);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (b) edge (e);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (b) edge (a);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (a) edge (c);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (a) edge (d);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (e) edge (a);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=north}] (e) edge (d);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (c) edge node{send} (d);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (c) edge node{send} (f);
      \node (b) at (1, 1) {\compmailr};
      \node (c) at (2, -0.5) {\compmailr};
      \node (f) at (5, 0) {\compmailr};
      \node (a) at (0, 0) {\compmailr};
      \node (e) at (4, 2) {\compmailr};
      \node (data) at (1, -1) {\includegraphics[scale=0.3]{img/fail.png} BANDWIDTH};
      \node (coverage) at (2.5, -1) {\includegraphics[scale=0.3]{img/ok.png} COVERAGE};
      \node (fail3) at (4, -1) {\includegraphics[scale=0.3]{img/ok.png} DELAY};
   }

  \end{tikzpicture}
\end{figure}

\end{frame}

\begin{frame}
  \frametitle{Pull Protocol}

\begin{figure}[h]
  \begin{tikzpicture}[scale=1.8]
    \clip (-0.5, 2.2) rectangle (6, -1.5);
    \node (d) at (3, 1) {\compmailb};
    \only<1> {
      \node (b) at (1, 1) {\compmailr};
      \node (a) at (0, 0) {\comp};
      \node (c) at (2, -0.5) {\comp};
      \node (e) at (4, 2) {\comp};
      \node (f) at (5, 0) {\comp};
      \draw[->, black!60!blue, every node/.style={sloped,anchor=south}] (e) edge[bend right] node{ask} (d);
      \draw[->, black!60!blue, every node/.style={sloped,anchor=south}] (a) edge[bend right] node{ask} (b);
      \draw[->, black!60!blue, every node/.style={sloped,anchor=south}] (f) edge[bend right=10] node{ask} (c);
    }
    \only<2> {
      \node (b) at (1, 1) {\compmailr};
      \node (a) at (0, 0) {\compmailr};
      \node (e) at (4, 2) {\compmailb};
      \node (c) at (2, -0.5) {\comp};
      \node (f) at (5, 0) {\comp};
      \draw[->, black!60!blue, every node/.style={sloped,anchor=south}] (e) edge[bend right] node{ask} (d);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (d) edge[bend right] node{send} (e);
      \draw[->, black!60!blue, every node/.style={sloped,anchor=south}] (a) edge[bend right] node{ask} (b);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (b) edge[bend right] node{send} (a);
      \draw[->, black!60!blue, every node/.style={sloped,anchor=south}] (f) edge[bend right=10] node{ask} (c);
      \draw[->, black!60!red, every node/.style={sloped,anchor=north}] (c) edge[bend right=10] node{fail} (f);
    }
    \only<3> {
      \node (a) at (0, 0) {\compmailr};
      \node (e) at (4, 2) {\compmailb};
      \node (c) at (2, -0.5) {\compmailr};
      \node (f) at (5, 0) {\compmailb};
      \node (b) at (1, 1) {\compmailbr};
      \draw[->, black!60!blue, every node/.style={sloped,anchor=south}] (b) edge[bend right] node{ask} (d);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (d) edge[bend right] node{send} (b);
      \draw[->, black!60!blue, every node/.style={sloped,anchor=south}] (f) edge[bend right] node{ask} (e);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (e) edge[bend right] node{send} (f);
      \draw[->, black!60!blue, every node/.style={sloped,anchor=south}] (c) edge[bend right] node{ask} (a);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (a) edge[bend right] node{send} (c);
      \node (data) at (1, -1) {\includegraphics[scale=0.3]{img/ok.png} BANDWIDTH};
      \node (coverage) at (2.5, -1) {\includegraphics[scale=0.3]{img/ok.png} COVERAGE};
      \node (fail3) at (4, -1) {\includegraphics[scale=0.3]{img/fail.png} DELAY};
    }
  \end{tikzpicture}
\end{figure}
\end{frame}

\begin{frame}
  \frametitle{Push and Pull, Best of Both Worlds?}
\begin{figure}[h]
  \begin{tikzpicture}[scale=1.8]
    \clip (-0.5, 2.2) rectangle (6, -1.5);
    \node (a) at (0, 0) {\compmailr};
    \node (b) at (1, 1) {\compmailr};
    \node (c) at (2, -0.5) {\compmailr};
    \node (d) at (3, 1) {\compmailr};
    \node (f) at (5, 0) {\compmailr};
    \node (e) at (4, 2) {\compmailr};
    \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (d) edge node{send} (f);
    \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (d) edge node{send} (b);
    \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (f) edge (c);
    \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (f) edge (d);
    \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (b) edge node{send} (c);
    \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (c) edge node{send} (a);
    \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (b) edge node{send} (a);
    \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (c) edge node{send} (d);
    \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (a) edge (f);
    \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (a) edge (d);
    \draw[->, black!60!blue, every node/.style={sloped,anchor=south}] (e) edge[bend right] node{ask} (d);
    \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (d) edge[bend right] node{send} (e);
    \node (data) at (1, -1) {\includegraphics[scale=0.3]{img/meh.png} BANDWIDTH};
    \node (coverage) at (2.5, -1) {\includegraphics[scale=0.3]{img/ok.png} COVERAGE};
    \node (fail3) at (4, -1) {\includegraphics[scale=0.3]{img/meh.png} DELAY};
  \end{tikzpicture}
\end{figure}

\end{frame}

\iffalse
\begin{frame}[b]
  \frametitle{Push Protocols Ignore Nodes Knowledge}
\begin{figure}[h]
  \begin{tikzpicture}[scale=2]
    \tikzstyle{n1}=[circle, draw, ultra thick];
    \tikzstyle{actb}=[diagonal fill={blue!20}{red!20}];
    \tikzstyle{act1}=[fill=blue!20];
    \tikzstyle{act2}=[fill=red!20];
    \node (a) at (0, 0) {\compmailb};
    \node (b) at (1, 1) {\compmailr};
    \node (c) at (2, -0.5) {\compmailb};
    \node (d) at (3, 1) {\compmailr};
    \node (e) at (4, 2) {\compmailb};
    \node (f) at (5, 0) {\compmailr};
    \only<2> {
      \node (b) at (1, 1) {\compmailbr};
      \node (e) at (4, 2) {\compmailbr};
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (a) edge node{send \textcolor{black!20!blue}{blue}} (b);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (a) edge node{send \textcolor{black!20!blue}{blue}} (c);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (f) edge node{send \textcolor{black!20!red}{red}} (d);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (f) edge node{send \textcolor{black!20!red}{red}} (e);
    }
    \only<3> {
      \node (b) at (1, 1) {\compmailbr};
      \node (e) at (4, 2) {\compmailbr};
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (a) edge (b);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (a) edge (c);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (f) edge (d);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (f) edge (e);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (e) edge node{send \textcolor{black!20!red}{red}} (d);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (e) edge node{send \textcolor{black!20!red}{red}} (b);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (b) edge node{send \textcolor{black!20!blue}{blue}} (c);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (b) edge[bend left] node{send \textcolor{black!20!blue}{blue}} (e);
    }
    \only<4> {
      \node[red, text width=6cm, align=left] at (1.5,2.2) {dissemination stopped\\only 2 nodes received both messages};
      \node (b) at (1, 1) {\compmailbr};
      \node (e) at (4, 2) {\compmailbr};
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (a) edge (b);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (a) edge (c);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (f) edge (d);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (f) edge (e);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (e) edge (d);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (e) edge (b);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (b) edge (c);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (b) edge[bend left] (e);
    }
  \end{tikzpicture}
\end{figure}
\end{frame}
\fi

\begin{frame}[b]
  \frametitle{Theoretically, Can We Send More Useful Information?}
\begin{figure}[h]
  \begin{tikzpicture}[scale=1.8]
    \clip (-0.5, 2.5) rectangle (6, -1.5);
    \node (a) at (0, 0) {\compmailb};
    \node (c) at (2, -0.5) {\compmailb};
    \node (d) at (3, 1) {\compmailr};
    \node (f) at (5, 0) {\compmailr};
    \node (b) at (1, 1) {\compmailbr};
    \node (e) at (4, 2) {\compmailbr};
    \only<1> {
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (a) edge node{send \textcolor{black!20!blue}{blue}} (b);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (a) edge node{send \textcolor{black!20!blue}{blue}} (c);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (f) edge node{send \textcolor{black!20!red}{red}} (d);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (f) edge node{send \textcolor{black!20!red}{red}} (e);
    }
    \only<2> {
      \node (c) at (2, -0.5) {\compmailbr};
      \node (d) at (3, 1) {\compmailbr};
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (a) edge (b);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (a) edge (c);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (f) edge (d);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (f) edge (e);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (e) edge node{send \textcolor{black!20!red}{red} $\oplus$ \textcolor{black!20!blue}{blue}} (d);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (e) edge node{send \textcolor{black!20!red}{red} $\oplus$ \textcolor{black!20!blue}{blue}} (b);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (b) edge node{send \textcolor{black!20!blue}{blue} $\oplus$ \textcolor{black!20!red}{red} } (c);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (b) edge[bend left] node{send \textcolor{black!20!blue}{blue} $\oplus$ \textcolor{black!20!red}{red} } (e);
    }
    \only<3> {
      \node (c) at (2, -0.5) {\compmailbr};
      \node (d) at (3, 1) {\compmailbr};
      \node (a) at (0, 0) {\compmailbr};
      \node (f) at (5, 0) {\compmailbr};
      \node[draw=none] (g) at (3, 0.5) {};
      \node[draw=none] (h) at (2, 0.) {};
      \node[draw=none] (i) at (2.5, 0.5) {};
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (a) edge (b);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (a) edge (c);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (f) edge (d);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (f) edge (e);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (e) edge (d);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (e) edge (b);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (b) edge (c);
      \draw[->, dashed, gray, every node/.style={sloped,anchor=south}] (b) edge[bend left] (e);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (d) edge (i);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (d) edge (g);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (c) edge node{send \textcolor{black!20!blue}{blue} $\oplus$ \textcolor{black!20!red}{red} } (f);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (c) edge (h);
      \draw[->, black!60!blue, every node/.style={sloped,anchor=north}] (a) edge[bend right] node{ask} (c);
      \draw[->, black!60!green, every node/.style={sloped,anchor=south}] (c) edge[bend right] node{send \textcolor{black!20!blue}{blue} $\oplus$ \textcolor{black!20!red}{red} } (a);
    \node (data) at (1, -1.2) {\includegraphics[scale=0.3]{img/down.png} BANDWIDTH};
    \node (coverage) at (2.5, -1.2) {\includegraphics[scale=0.3]{img/ok.png} COVERAGE};
    \node (fail3) at (4, -1.2) {\includegraphics[scale=0.3]{img/down.png} DELAY};
    }
  \end{tikzpicture}
\end{figure}
\end{frame}

\begin{frame}[t]
  \frametitle{Theory Behind Network Coding Rumor Spreading}


  \only<1> {
  \begin{alertblock}{Message encoding}
  $M^1, ..., M^n$ are $n$ messages encoded over $\mathbb{F}_{2^m}$. \\
  $c = c_1, ..., c_n$ are $n$ (random) coefficients. \\
  $X = \sum_{i=1}^{n} c_i M^i$ is a linear combination. $(c, X)$ is sent on network.
  \end{alertblock}

  \vspace{0.5em}
  \begin{columns}
  \begin{column}{0.5\textwidth}
  \includegraphics[width=5.2cm]{img/proba_redundant.png}
  \end{column}
  \begin{column}{0.5\textwidth}
    \begin{itemize}
      \item[] \includegraphics[scale=0.3]{img/ok.png} BANDWIDTH \\
      \item[] \includegraphics[scale=0.3]{img/ok.png} COVERAGE \\
      \item[] \includegraphics[scale=0.3]{img/ok.png} DELAY
    \end{itemize}
  \end{column}
  \end{columns}
  \vspace{0.5em}
  \begin{center}
  \Large Problem solved?
  \end{center}
  }
  \only<2> {
    \begin{alertblock}{\textbf{Global} decision is required}
    \begin{itemize}
      \item $M^1, ..., M^n$ $\rightarrow$ $n$ must be limited by creating groups of messages (generation) to limit the encoding/decoding complexity
      \item $c = c_1, ..., c_n$ $\rightarrow$ $c_i$ must be linked to the same message for everyone
    \end{itemize}
    \end{alertblock}

  \vspace{1em}
  \begin{columns}
  \begin{column}{0.5\textwidth}
    \begin{center}
    \includegraphics[scale=1]{img/stop.png} \\
    \Large \textbf{Global} decision \\
    is impossible
    \end{center}
  \end{column}
  \begin{column}{0.5\textwidth}
    \begin{itemize}
      \item[] \includegraphics[scale=0.3]{img/fail.png} MESSAGE GENERATION \\
      \item[] \includegraphics[scale=0.3]{img/fail.png} MESSAGE ORDERING
    \end{itemize}
  \vspace{1em}
    Can we take \textbf{local} decisions?
  \end{column}
  \end{columns}

  \vspace{0.5em}
  \begin{center}
  \fcolorbox{red}{white} {\Large \textbf{Local} decisions to bridge the gap between theory and practice}
  \end{center}
  }
\end{frame}

\section{CHEPIN: Make Network Coding Practicable}

\begin{frame}[t]
  \frametitle{Local Decision to Order Messages}

  \begin{enumerate}
    \item Emitting node chooses a \textcolor{red}{unique identifier} (e.g. 0xc8a4)
    \item \textcolor{red}{Mapping} between identifier and position in vector/matrix is \textcolor{red}{kept locally}
    \item On network, \textcolor{red}{coefficient} is associated with its \textcolor{red}{unique identifier}
  \end{enumerate}

\begin{figure}[b]
  \begin{tikzpicture}[scale=2]
    \tikzstyle{n1}=[circle, draw, ultra thick];
    \tikzstyle{act}=[fill=blue!20];
    \tikzstyle{actp}=[diagonal fill={blue!20}{white}];
    \tikzstyle{actb}=[diagonal fill={blue!20}{red!20}];
    \node (a) at (0, 0) {\compmailbr};
    \node (b) at (4, 0) {\compmailr};
    \node[black, text width=2cm, align=center] at (0,-0.6) {
      \small
	  \[ 
	    \begin{blockarray}{ccccc}
	    \text{\tiny 0x12f3} & \text{\tiny 0xc8a4} & \text{\tiny $M^{m}_{1}$} & \text{\tiny ...} & \text{\tiny $M^{m}_{n}$} \\
	    \begin{block}{(ccccc)}
	    1 & 0 & M^{1}_{1} & ... & M^{1}_{n} \\
	    0 & 1 & M^{2}_{1} & ... & M^{2}_{n} \\
	    \end{block}
	    \end{blockarray}
	  \]
    };
    \only<1> {
        \node[black, text width=2cm, align=center] at (3,-0.6) {
          \small
          \[ 
            \begin{blockarray}{cccc}
            \text{\tiny 0xc8a4} & \text{\tiny $M^{m}_{1}$} & \text{\tiny ...} & \text{\tiny $M^{m}_{n}$} \\
            \begin{block}{(cccc)}
            1 & M^{2}_{1} & ... & M^{2}_{n} \\
            \end{block}
            \end{blockarray}
          \]
        };
    }

    \only<2> {
        \node[black, text width=2cm, align=center] at (3,-0.6) {
          \small
          \[ 
            \begin{blockarray}{ccccc}
            \text{\tiny 0xc8a4} & \text{\tiny \textcolor{black!60!green}{0x12f3}} & \text{\tiny $M^{m}_{1}$} & \text{\tiny ...} & \text{\tiny $M^{m}_{n}$} \\
            \begin{block}{(ccccc)}
            1 & \textcolor{black!60!green}{0} & M^{2}_{1} & ... & M^{2}_{n} \\
	        \textcolor{black!60!green}{78} & \textcolor{black!60!green}{13} & \textcolor{black!60!green}{X_{1}} & \textcolor{black!60!green}{...} & \textcolor{black!60!green}{X_{n}} \\
            \end{block}
            \end{blockarray}
          \]
        };
      %\node (b) at (4, 0) {B};
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (a) edge node{send $\{(\text{0x12f3}, 13), (\text{0xc8a4}, 78)\}, (X^1, ..., X^n) $} (b);
    }

    \only<3> {
        \node[black, text width=2cm, align=center] at (3,-0.6) {
          \small
          \[ 
            \begin{blockarray}{ccccc}
            \text{\tiny 0xc8a4} & \text{\tiny \textcolor{black!60!green}{0x12f3}} & \text{\tiny $M^{m}_{1}$} & \text{\tiny ...} & \text{\tiny $M^{m}_{n}$} \\
            \begin{block}{(ccccc)}
            1 & \textcolor{black!60!green}{0} & M^{2}_{1} & ... & M^{2}_{n} \\
	        \textcolor{red}{0} & \textcolor{red}{1} & \textcolor{red}{M^{1}_{1}} & \textcolor{red}{...} & \textcolor{red}{M^{1}_{n}} \\
            \end{block}
            \end{blockarray}
          \]
        };
      \node (b) at (4, 0) {\compmailbr};
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (a) edge node{send $\{(\text{0x12f3}, 13), (\text{0xc8a4}, 78)\}, (X^1, ..., X^n) $} (b);
    }
  \end{tikzpicture}
\end{figure}

  \only<3> {
    \begin{center}
    Dynamically adapt to the number of messages    

    \vspace{1em}
    \includegraphics[scale=0.3]{img/fail.png} MESSAGE GENERATION
    \hspace{1.3em}
    \includegraphics[scale=0.3]{img/ok.png} MESSAGE ORDERING
    \end{center}
  }
\end{frame}

\begin{frame}[t]
  \frametitle{Local Decision to Group Messages in Generations}

  %\textbf{Generation:} encode message only in the same group to improve perfomances.
  %\textbf{For $n$ messages, $n$ id.+coef. are sent and decoding complexity is $O(n^3)$}
  %$\rightarrow$ Limit the number of messages encoded together by encoding only messages with same \textbf{generation}.
  %\vspace{1em}

  %\vspace{1em}
  \begin{columns}
  \begin{column}{0.5\textwidth}
  \textbf{Based on Lamport Timestamps.} \\
  Same timestamp = same generation.
  \end{column}
  \begin{column}{0.5\textwidth}
  $C_k$ is used to set message generation. \\
  $C_k$ is updated when relaying and emitting.
  \end{column}
  \end{columns}
  \vspace{1em}
  %\begin{description}[align=left]
  %\item [Stable over network size] nodes receive messages in $O(\log s)$ hopes where $s$ is the network size. Message delivery latency evolves slowly, g eneration size remains stable.
  %\item [$C_k$ update rule can be locally adapted] to cope with other parameters variation and maintain desired generation size.
  %\end{description}

\only<1-7> {
\begin{figure}[h]
  \begin{tikzpicture}[scale=2]
    \only<1> {
      \node (a) at (0, 0) {\comp $C_0=0$};
      \node (b) at (0.5, 1.5) {\comp $C_1=0$};
      \node (c) at (3.5, 0) {\comp $C_2=0$};
      \node (d) at (3, 1.5) {\comp $C_3=0$};
    }
    \only<2> {
      \node (a) at (0, 0) {\compmailr $C_0=1$};
      \node (b) at (0.5, 1.5) {\comp $C_1=0$};
      \node (c) at (3.5, 0) {\comp $C_2=0$};
      \node (d) at (3, 1.5) {\compmailb $C_3=1$};
    }
    \only<3> {
      \node (a) at (0, 0) {\compmailr $C_0=1$};
      \node (b) at (0.5, 1.5) {\compmailr $C_1=1$};
      \node (c) at (3.5, 0) {\compmailb $C_2=1$};
      \node (d) at (3, 1.5) {\compmailbr $C_3=1$};
      \node (f) at (3.8, 1.5) {};
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (a) edge node{send G=0, \textcolor{black!20!red}{red}} (b);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (a) edge node{send G=0, \textcolor{black!20!red}{red}} (d);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (d) edge node{send G=0, \textcolor{black!20!blue}{blue}} (c);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (d) edge (f);
    }
    \only<4> {
      \node (a) at (0, 0) {\compmailry $C_0=2$};
      \node (c) at (3.5, 0) {\compmailb $C_2=1$};
      \node (b) at (0.5, 1.5) {\compmailr $C_1=1$};
      \node (d) at (3, 1.5) {\compmailbr $C_3=1$};
      \node (e) at (-0.3, 1.2) {};
      \node (f) at (-0.3, 1.5) {};
      \node (g) at (3.8, 1.5) {};
      \node (h) at (3.9, 0.5) {};
      \node (i) at (3.6, 0.5) {};
      \node (j) at (1.5, 1.5) {};
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (d) edge node{sending...} (j);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (d) edge (g);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (b) edge (e);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (b) edge (f);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (c) edge (h);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (c) edge (i);
    }
    \only<5> {
      \node (a) at (0, 0) {\compmailry $C_0=2$};
      \node (d) at (3, 1.5) {\compmailbr $C_3=1$};
      \node (b) at (0.5, 1.5) {\compmailbr $C_1=1$};
      \node (c) at (3.5, 0) {\compmailby $C_2=2$};
      \node (j) at (-0.3, 0.5) {};
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (d) edge node{send G=0, (c,X)} (b);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (a) edge node{send G=1, \textcolor{black!20!yellow}{yellow}} (c);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (a) edge (j);
    }
    \only<6> {
      \node (c) at (3.5, 0) {\compmailbry $C_2=2$};
      \node (b) at (0.5, 1.5) {\compmailbr $C_1=1$};
      \node (a) at (0, 0) {\compmailbry $C_0=2$};
      \node (d) at (3, 1.5) {\compmailbr $C_3=1$};
      \node (h) at (3.9, 0.5) {};
      \node (i) at (3.6, 0.5) {};
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (b) edge node{send G=0, (c,X)} (a);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (b) edge node{send G=0, (c,X)} (c);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (c) edge (h);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (c) edge (i);
    }
    \only<7> {
      \node (c) at (3.5, 0) {\compmailbry $C_2=2$};
      \node (b) at (0.5, 1.5) {\compmailbr $C_1=1$};
      \node (a) at (0, 0) {\compmailbry $C_0=2$};
      \node (d) at (3, 1.5) {\compmailbr $C_3=1$};
      \node (h) at (3.9, 0.5) {};
      \node (j) at (-0.3, 0.5) {};
      \node (k) at (-0.1, 0.5) {};
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (c) edge node{send G=0, (c,X)} (d);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (c) edge (h);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (a) edge (j);
      \draw[->, black!60!green, every node/.style={sloped,anchor=north}] (a) edge (k);
    }
  \end{tikzpicture}
\end{figure}
}
\only<7> {
  %\vspace{2em}
  \begin{center}
    \includegraphics[scale=0.3]{img/ok.png} MESSAGE GENERATION
    \hspace{1.3em}
    \includegraphics[scale=0.3]{img/ok.png} MESSAGE ORDERING
  \end{center}
}
\end{frame}

\section{Evaluating CHEPIN against State of the Art}

\begin{frame}
  \frametitle{State of the Art Rumor Spreading Algorithm}

  \begin{columns}
  \begin{column}{0.6\textwidth}
    \begin{alertblock}{State of the Art: Pulp\footnotemark[1]}
      \begin{itemize}
        \item Multisource push-pull protocol
        \item Short push phase completed by pull phase
        \item Dynamically adapt pull frequency
      \end{itemize}
    \end{alertblock}

    \begin{alertblock}{Our algorithm: CHEPIN}
      \begin{itemize}
        \item Applied to Pulp
        \item Exchange linear combinations instead of messages
      \end{itemize}
    \end{alertblock}
  \end{column}
  \begin{column}{0.4\textwidth}
    
    Our evaluation testbed:
    \begin{itemize}
      \item Omnet++ simulation
      \item Planetlab latencies
      \item 1000 nodes
      \item 1000 messages
      \item 150 msg/sec
      \item 1 kB messages
      \item same algo. config.
    \end{itemize}
  \end{column}
  \end{columns}
  \footnotetext[1]{\fullcite{felber_pulp:_2012}}
\end{frame}

\begin{frame}
  \frametitle{CHEPIN vs Pulp: Behaviour on Configuration Change}
  \begin{columns}
  \begin{column}{0.7\textwidth}
  \includegraphics[width=0.9\textwidth]{r/plot.pdf}
  \end{column}

  \begin{column}{0.3\textwidth}
    Various combinations of \textbf{fanout} and \textbf{TTL} tried.

    \vspace{1em}

    \textcolor{black!60!green}{\textbf{CHEPIN} always has acceptable results.}
 
    \vspace{1em}

    \textcolor{black!60!red}{\textbf{Pulp} needs fine tuning.}
  \end{column}
  \end{columns}
\end{frame}

\begin{frame}
  \frametitle{CHEPIN vs Pulp: Behaviour on Network Change}
\begin{figure}[h]
     \includegraphics[width=8.5cm]{img/stability.png}
\end{figure}
  \begin{columns}
  \begin{column}{0.3\textwidth}
    \textcolor{black!60!green}{\textbf{CHEPIN} still uses less bandwidth when varying message frequency.}
  \end{column}
  \begin{column}{0.3\textwidth}
    \textcolor{black!60!green}{\textbf{CHEPIN} still uses less bandwidth when varying latency.}
  \end{column}
  \begin{column}{0.3\textwidth}
    \textcolor{black!60!green}{\textbf{CHEPIN} generation size remains stable.}
  \end{column}
  \end{columns}
\end{frame}

\begin{frame}
  \frametitle{CHEPIN vs Pulp: Internals 1/2}
  \begin{columns}
  \begin{column}{0.3\textwidth}


  
  \textcolor{black!60!blue}{\textbf{CHEPIN} spreads a larger fraction of its messages during the push phase.}
  
  \vspace{1em}
  
  \textcolor{black!60!green}{\textbf{CHEPIN} sends fewer packets on the network.}

  \end{column}
  \begin{column}{0.7\textwidth}
  \begin{figure}[h]
     \includegraphics[width=7.0cm]{img/packets.png}
  \end{figure}
  \end{column}
  \end{columns}

\end{frame}

\begin{frame}
  \frametitle{CHEPIN vs Pulp: Internals 2/2}

  \begin{columns}
  \begin{column}{0.7\textwidth}
  \begin{figure}[h]
     \includegraphics[width=6.5cm]{img/latency.png}
  \end{figure}

  \end{column}
  \begin{column}{0.3\textwidth}
  \textcolor{black!60!green}{\textbf{CHEPIN} message delivery delay distribution is lower than the Pulp one.}

  \end{column}
  \end{columns}
\end{frame}

\begin{frame}
  \frametitle{Conclusion}

  CHEPIN:
  \begin{itemize}
    \item Reduce bandwidth overhead
    \item Reduce delivery delay
    \item Adapt to existing Rumor Spreading algorithms
  \end{itemize}

  \vspace{1em}
  Future work:
  \begin{itemize}
    \item Better adaptivity, better sharing of knowledge
    \item Implementation in a real world solution, assesment of the computing cost
  \end{itemize}
  \vspace{1em}
  Back to Bitcoin: \Large\textcolor{black!60!green}{2.3x} \normalsize instead of \Large \textcolor{red}{16x} \normalsize redundancy

\end{frame}

\end{document}

